#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>

void sqlinit(char *);
void showmenu();
void db_error();
void show_usage();
char *sse(char *);
char *ssb(char *);
void editproc(int);
void saveproc(int);
int isproc(int);
void getcodestatus(int);

EXEC SQL INCLUDE sqlca;
char procarray[50][100];
char tempfile[]="/tmp/proctempXXXXXX";

int main(int argc,char *argv[]){

  char buf[1000],buf2[2],buf3[2],*buf4,buf5[255];
  FILE *f;

  buf4=getenv("PROCEDITOR");
  if(buf4==NULL){
    printf("\r\nYou must set the environment variable PROCEDITOR to the name of your text editor\r\n");
    exit(0);
  }

  mktemp(tempfile);

  if(argv[1]==NULL)
     show_usage();

  sqlinit(argv[1]);

  showmenu();

  printf("\r\nEdit Which:");
  gets(buf2);

  if(strncmp(buf2,"q",1)==0)
    exit(0);

  editproc(atoi(buf2));
  sprintf(buf5,"%s %s",buf4,tempfile);
  system(buf5);

  printf("\r\nSubmit to Oracle? [y/n]:");
  gets(buf3);

  if(strncmp(buf3,"y",1)==0){
    saveproc(atoi(buf2));
  }else{
    printf("\r\nNot Saved, Later\r\n");
    exit(0);
  }

}

void sqlinit(char *cstring)
{

EXEC SQL WHENEVER SQLERROR DO db_error();
EXEC SQL CONNECT:cstring;

}

void showmenu()
{

char buf1[255];
int a=0;

EXEC SQL DECLARE msg CURSOR FOR
      SELECT name
      FROM user_source where line = 1;

    EXEC SQL OPEN msg;
    EXEC SQL WHENEVER NOT FOUND DO break;
    for (;;)
      {
        a++;
        EXEC SQL
          FETCH msg
          INTO :buf1;

        strcpy(procarray[a],sse(buf1));    
        printf("%d: %s\r\n",a,sse(buf1));
      }
      EXEC SQL CLOSE msg; 
      EXEC SQL WHENEVER NOT FOUND CONTINUE;

}

void db_error ()
{
  char message_buffer[512];
  size_t buffer_size;
  size_t message_length;

  buffer_size = sizeof (message_buffer);
  sqlglm (message_buffer, &buffer_size, &message_length);
  printf("Database Error\r\n");
  printf ("\n%.*s\n", message_length, message_buffer);
  exit(0);
}  


void show_usage()
{
printf("\r\nTerm Procedit 1.0 by Matthew Chappee matthew@mattshouse.com\r\n");
printf("Usage:\r\n");
printf("tprocedit username/password@tnsalias\r\n\r\n");
printf("Example: tprocedit matthew/cim@oneworld\r\n");
exit(0);
}

void editproc(int oproc)
{
FILE *stream;
char buf[255],buf2[1000];
int b=0,c=0,d=0;

strcpy(buf,procarray[oproc]);

EXEC SQL DECLARE msg2 CURSOR FOR
    SELECT text
    FROM user_source
    WHERE name = :buf
    ORDER BY line;

EXEC SQL OPEN msg2;

stream = fopen(tempfile,"w");

EXEC SQL
   FETCH msg2
   INTO :buf2;

sse(buf2);

while(buf2[b]){
 if(buf2[b]==' ')
    c++;   
 
 if(buf2[b]!=' ' && c)
    d++;
   
 if(buf2[b]==' ' && d)
    break; 
 
 b++;
}

fprintf(stream,buf2+b+1);

EXEC SQL WHENEVER NOT FOUND DO break;

for (;;)
    {

     EXEC SQL        
      FETCH msg2
      INTO :buf2;

     fprintf(stream,sse(buf2));

    }
  EXEC SQL CLOSE msg2;
  EXEC SQL WHENEVER NOT FOUND CONTINUE;
  fclose(stream);

}

void saveproc(int oproc)
{
char buf[255],*buf2,buf3[500],*buf1;
FILE *stream;
struct stat fs;

strcpy(buf,procarray[oproc]);
stream = fopen(tempfile,"r");

fstat(fileno(stream),&fs);

buf2=(char *)malloc(fs.st_size);
fread(buf2,1,fs.st_size,stream);
fclose(stream);

if(isproc(oproc))
  sprintf(buf3,"CREATE OR REPLACE FUNCTION %s ",buf);
else
  sprintf(buf3,"CREATE OR REPLACE PROCEDURE %s ",buf);

buf1=(char *)malloc(strlen(buf3) + strlen(buf2) + 2);

strcpy(buf1,buf3);
strcat(buf1,buf2);
free(buf2);

EXEC SQL EXECUTE IMMEDIATE :buf1;
free(buf1);

getcodestatus(oproc);

}

int isproc(int oproc)
{

char buf[255],buf1[255];

strcpy(buf,procarray[oproc]);

    EXEC SQL
      SELECT type
      INTO :buf1
      FROM user_source 
      WHERE name = :buf
      AND line = 1;

   if(strncmp(buf1,"PROC",4)){
      return 1;
   }else{
      return 0;
   }
   
   
}


void getcodestatus(int oproc)
{
char buf[255],buf1[4000],buf2[255],buf3[20000];

strcpy(buf,procarray[oproc]);

EXEC SQL DECLARE msg6 CURSOR FOR
    SELECT status
    FROM user_objects
    WHERE object_name = :buf;

  EXEC SQL OPEN msg6;
  
  EXEC SQL        
      FETCH msg6
      INTO :buf2;

  EXEC SQL CLOSE msg6;

  if(strncmp(sse(ssb(buf2)),"INVALID",7)==0){
    EXEC SQL DECLARE msg7 CURSOR FOR
    SELECT text
    FROM user_errors
    WHERE name = :buf;

  EXEC SQL OPEN msg7;
  EXEC SQL WHENEVER NOT FOUND DO break;

  for (;;)
    {

     EXEC SQL        
      FETCH msg7
      INTO :buf1;
       
     strcat(buf3,sse(ssb(buf1)));

    }

    EXEC SQL CLOSE msg7; 
    EXEC SQL WHENEVER NOT FOUND CONTINUE;
    printf("\r\nThe Code is Invalid for the following reason(s):\r\n%s\r\n",buf3);
  }else{
    printf("\r\nThe code compiled and is Valid\r\n");
  }


}
